(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
    // If the importer is in node compatibility mode or this is not an ESM
    // file that has been converted to a CommonJS file using a Babel-
    // compatible transform (i.e. "__esModule" has not been set), then set
    // "default" to the CommonJS "module.exports" for node compatibility.
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
    mod
  ));

  // external-global:cockpit
  var require_cockpit = __commonJS({
    "external-global:cockpit"(exports, module) {
      module.exports = cockpit;
    }
  });

  // pkg/playground/service.js
  var import_cockpit2 = __toESM(require_cockpit(), 1);

  // pkg/lib/service.js
  var import_cockpit = __toESM(require_cockpit(), 1);
  var systemd_client;
  var systemd_manager;
  function wait_valid(proxy2, callback) {
    proxy2.wait(() => {
      if (proxy2.valid)
        callback();
    });
  }
  function with_systemd_manager(done) {
    if (!systemd_manager) {
      systemd_client = import_cockpit.default.dbus("org.freedesktop.systemd1");
      systemd_manager = systemd_client.proxy(
        "org.freedesktop.systemd1.Manager",
        "/org/freedesktop/systemd1"
      );
      wait_valid(systemd_manager, () => {
        systemd_manager.Subscribe().catch((error) => {
          if (error.name != "org.freedesktop.systemd1.AlreadySubscribed" && error.name != "org.freedesktop.DBus.Error.FileExists")
            console.warn("Subscribing to systemd signals failed", error);
        });
      });
    }
    wait_valid(systemd_manager, done);
  }
  function proxy(name, kind) {
    const self = {
      exists: null,
      state: null,
      enabled: null,
      wait,
      start,
      stop,
      restart,
      tryRestart,
      enable,
      disable,
      getRunJournal
    };
    import_cockpit.default.event_target(self);
    let unit, details;
    let wait_promise_resolve;
    const wait_promise = new Promise((resolve) => {
      wait_promise_resolve = resolve;
    });
    if (name.indexOf(".") == -1)
      name = name + ".service";
    if (kind === void 0)
      kind = "Service";
    function update_from_unit() {
      self.exists = unit.LoadState != "not-found" || unit.ActiveState != "inactive";
      if (unit.ActiveState == "activating")
        self.state = "starting";
      else if (unit.ActiveState == "deactivating")
        self.state = "stopping";
      else if (unit.ActiveState == "active" || unit.ActiveState == "reloading")
        self.state = "running";
      else if (unit.ActiveState == "failed")
        self.state = "failed";
      else if (unit.ActiveState == "inactive" && self.exists)
        self.state = "stopped";
      else
        self.state = void 0;
      if (unit.UnitFileState == "enabled" || unit.UnitFileState == "linked")
        self.enabled = true;
      else if (unit.UnitFileState == "disabled" || unit.UnitFileState == "masked")
        self.enabled = false;
      else
        self.enabled = void 0;
      self.unit = unit;
      self.dispatchEvent("changed");
      wait_promise_resolve();
    }
    function update_from_details() {
      self.details = details;
      self.service = details;
      self.dispatchEvent("changed");
    }
    with_systemd_manager(function() {
      systemd_manager.LoadUnit(name).then((path) => {
        unit = systemd_client.proxy("org.freedesktop.systemd1.Unit", path);
        unit.addEventListener("changed", update_from_unit);
        wait_valid(unit, update_from_unit);
        details = systemd_client.proxy("org.freedesktop.systemd1." + kind, path);
        details.addEventListener("changed", update_from_details);
        wait_valid(details, update_from_details);
      }).catch(() => {
        self.exists = false;
        self.dispatchEvent("changed");
      });
    });
    function refresh() {
      if (!unit || !details)
        return Promise.resolve();
      function refresh_interface(path, iface) {
        return systemd_client.call(path, "org.freedesktop.DBus.Properties", "GetAll", [iface]).then(([result]) => {
          const props = {};
          for (const p in result)
            props[p] = result[p].v;
          systemd_client.notify({ [unit.path]: { [iface]: props } });
        }).catch((error) => console.log(error));
      }
      return Promise.allSettled([
        refresh_interface(unit.path, "org.freedesktop.systemd1.Unit"),
        refresh_interface(details.path, "org.freedesktop.systemd1." + kind)
      ]);
    }
    function on_job_new_removed_refresh(event, number, path, unit_id, result) {
      if (unit_id == name)
        refresh();
    }
    systemd_manager.addEventListener("Reloading", (event, reloading) => {
      if (!reloading)
        refresh();
    });
    systemd_manager.addEventListener("JobNew", on_job_new_removed_refresh);
    systemd_manager.addEventListener("JobRemoved", on_job_new_removed_refresh);
    function wait(callback) {
      wait_promise.then(callback);
    }
    function call_manager(dbus, method, args) {
      return dbus.call(
        "/org/freedesktop/systemd1",
        "org.freedesktop.systemd1.Manager",
        method,
        args
      );
    }
    function call_manager_with_job(method, args) {
      return new Promise((resolve, reject) => {
        const dbus = import_cockpit.default.dbus("org.freedesktop.systemd1", { superuser: "try" });
        let pending_job_path;
        const subscription = dbus.subscribe(
          { interface: "org.freedesktop.systemd1.Manager", member: "JobRemoved" },
          (_path, _iface, _signal, [_number, path, _unit_id, result]) => {
            if (path == pending_job_path) {
              subscription.remove();
              dbus.close();
              refresh().then(() => {
                if (result === "done")
                  resolve();
                else
                  reject(new Error(`systemd job ${method} ${JSON.stringify(args)} failed with result ${result}`));
              });
            }
          }
        );
        call_manager(dbus, method, args).then(([path]) => {
          pending_job_path = path;
        }).catch(() => {
          dbus.close();
          reject();
        });
      });
    }
    function call_manager_with_reload(method, args) {
      const dbus = import_cockpit.default.dbus("org.freedesktop.systemd1", { superuser: "try" });
      return call_manager(dbus, method, args).then(() => call_manager(dbus, "Reload", [])).then(refresh).finally(dbus.close);
    }
    function start() {
      return call_manager_with_job("StartUnit", [name, "replace"]);
    }
    function stop() {
      return call_manager_with_job("StopUnit", [name, "replace"]);
    }
    function restart() {
      return call_manager_with_job("RestartUnit", [name, "replace"]);
    }
    function tryRestart() {
      return call_manager_with_job("TryRestartUnit", [name, "replace"]);
    }
    function enable() {
      return call_manager_with_reload("EnableUnitFiles", [[name], false, false]);
    }
    function disable() {
      return call_manager_with_reload("DisableUnitFiles", [[name], false]);
    }
    function getRunJournal(options) {
      if (!details || !details.ExecMainStartTimestamp)
        return Promise.reject(new Error("getRunJournal(): unit is not known"));
      const startTime = Math.floor(details.ExecMainStartTimestamp / 1e6);
      return import_cockpit.default.spawn(
        ["journalctl", "--unit", name, "--since=@" + startTime.toString()].concat(options || []),
        { superuser: "try", error: "message" }
      );
    }
    return self;
  }

  // pkg/playground/service.js
  document.addEventListener("DOMContentLoaded", () => {
    let proxy2;
    function navigate() {
      proxy2 = proxy(import_cockpit2.default.location.path[0] || "");
      function show() {
        function s(t) {
          document.getElementById(t).textContent = JSON.stringify(proxy2[t]);
        }
        s("exists");
        s("state");
        s("enabled");
      }
      proxy2.addEventListener("changed", show);
      show();
      document.body.removeAttribute("hidden");
    }
    function b(t) {
      document.getElementById(t).addEventListener("click", () => {
        proxy2[t]().catch((error) => console.error("action", t, "failed:", JSON.stringify(error)));
      });
    }
    b("start");
    b("stop");
    b("enable");
    b("disable");
    import_cockpit2.default.addEventListener("locationchanged", navigate);
    navigate();
  });
})();
//# sourceMappingURL=service.js.map
